#charset "us-ascii"
#include <adv3.h>
#include <en_us.h>

class Dollar: Thing
    vocabWords = 'dollar bill*bills'
    listWith = [dollarGroup]
    dollarGroupBaseName = ''
    collectiveGroups = [dollarCollective]
    dollarGroupName = (dollarGroupBaseName + ' dollar bill')
    countedDollarGroupName(cnt)
    { return spellIntBelow(cnt, 100) + ' ' + dollarGroupBaseName; }
;

class TwentyDollarBill: Dollar '20 dollar bill' '20 dollar bill' 
    isEquivalent = true
    dollarValue = 20
    dollarGroupBaseName = 'twenty'
;

class TenDollarBill: Dollar '10 dollar bill' '10 dollar bill' 
    isEquivalent = true
    dollarValue = 10
    dollarGroupBaseName = 'ten'
;

class FiveDollarBill: Dollar '5 dollar bill' '5 dollar bill' 
    isEquivalent = true
    dollarValue = 5
    dollarGroupBaseName = 'five'
;

class OneDollarBill: Dollar '1 dollar bill' '1 dollar bill' 
    isEquivalent = true
    dollarValue = 5
    dollarGroupBaseName = 'one'
;

dollarGroup: ListGroupParen
    showGroupCountName(first)
    {
        "<<spellIntBelowExt(first.length(), 100, 0, DigitFormatGroupSep)>> bills";
    }
    compareGroupItems(a, b) { return b.dollarValue - a.dollarValue; }
    showGroupItem(lister, obj, options, pov, info)
        {  say(obj.dollarGroupName); }
    showGroupItemCount(lister, first, options, pov, infoTab)
        {  say(first[1].countedDollarGroupName(first.length())); }
;

dollarCollective: ItemizingCollectiveGroup '*dollars' 'dollars'
;